/*
* This Java Bean and all of the other "Beans" in this offering are
* copyright 2002 by Peter Wayner. 
*   


 * This bean is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This bean is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * Or go to http://www.gnu.org
 * 
 
 */
public class LineItem {
   
   static MD5 md=new MD5();

   String s;
   String cleanS;// a version without whitespace.
   int canonicalPosition=-1;
   boolean notChosen=false;
   String sortString="";
   
   public String cleanString(String s){
     // return a version without bad troublesome characters. 
     StringBuffer ans=new StringBuffer();
     int len=s.length();
     char a;
     for (int i=0;i<len;i++){
        a=s.charAt(i);
        if ((a>='A') && (a<='Z')) ans.append(a);
        else if ((a>='a') && (a<'z')) ans.append(a);
        else if ((a>='0') && (a<'9')) ans.append(a);
        else if (!java.lang.Character.isWhitespace(a)) ans.append(a);
     }
     return ans.toString();
   
   }
   
   public LineItem(String a, int p){
      s=a;
      cleanS=cleanString(a);
      canonicalPosition=p;
   }
    public LineItem(String a){
      s=a;
      cleanS=cleanString(a);
   }
 
   public int getCanonicalPosition(){
     return canonicalPosition;
   }
   
   public String toString(){
     return "("+canonicalPosition+","+notChosen+") s=\""+s+"\" cleanS=\""+cleanS+"\" sort="+sortString;
   }
   
   public String getSortString(){
     return sortString;
   }
   
   public void setSortString(String password){
      md.clear();
      md.Update(password);
      md.Update(cleanS);
      sortString=md.asHex();
      //System.out.println("Set sort:"+this);

    }
   
   public void setSortString(){
     setSortString("nopassword");   
   }
   
   
   
}